//+------------------------------------------------------------------+
//|                                                  ShowTFAData.mq4 |
//|                                                           Candid |
//|                                         http://candid.110mb.com/ |
//+------------------------------------------------------------------+
#property copyright "Candid"
#property link      "http://candid.110mb.com/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 RoyalBlue

extern int		ind_Points				= 100;
extern double	ind_Percent				= 0.0;
extern int		Sample   				= 100;
extern int		Column   				= 2;

string FileName;
string IndName;
int iPercent;
int pos;
int h;
//int PreBars;
//datetime BarTime;
//int StartPos;

datetime T;
double Val;

double Buf[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
  iPercent = 100*ind_Percent;
  IndName = "TFAData("+ind_Points+","+iPercent+","+Sample+")";
  IndicatorShortName(IndName); 
  SetIndexBuffer(0,Buf);
  SetIndexStyle(0,DRAW_SECTION,EMPTY,2);
  SetIndexEmptyValue(0,0.0);
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
  ObjectDelete("Show_"+FileName);
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
  FileName = "TFA_"+Symbol()+"_"+ind_Points+"_"+iPercent+"_"+Sample+".txt";
  h = FileOpen(FileName,FILE_CSV|FILE_READ,';');
  if (h<1) {
    ObjectCreate("Show_"+FileName,OBJ_LABEL,WindowFind(IndName),0,0);
    ObjectSet("Show_"+FileName,OBJPROP_CORNER,0);
    ObjectSet("Show_"+FileName,OBJPROP_XDISTANCE,20);
    ObjectSet("Show_"+FileName,OBJPROP_YDISTANCE,20);
    ObjectSetText("Show_"+FileName,", -   .",30,"Times New Roman",Red);
    return(-1);
  }
  for (pos=Bars-1;pos>0;pos--) {
    while (T < Time[pos] && !FileIsEnding(h)) {
      T = FileReadNumber(h);
      for (int i=0;i<4;i++) {
        double TVal = FileReadNumber(h);
        if (i == Column-2) Val = TVal;
      }
    }
    if (T >= Time[pos] && T < Time[pos-1]) {
      Buf[pos] = Val;
    }
  }  //  for (pos=StartPos;pos>0;pos--)  
  FileClose(h); 
  return(0);
}
//+------------------------------------------------------------------+